#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <fcntl.h>
#include <time.h>
#include <unistd.h>
#include <sys/stat.h>
#include "globals.h"

void produce(int id, int fd, int count);

int main(int argc, char *argv[])
{
    if (argc != 3)
    {
        fprintf(stderr, "Usage: id count\n");
        return -1;
    }

    int id        = atoi(argv[1]);
    int max_items = atoi(argv[2]);

    // If this is Producer #1, remove the old FIFO
    // and create a new one.
    if (id == 1)
    {
        unlink(FIFO_PATH);
        mkfifo(FIFO_PATH, 0666);
    }

    // First open the FIFO in write-only mode.
    int fd = open(FIFO_PATH, O_WRONLY);

    // Produce and write items to write to the FIFO.
    produce(id, fd, max_items);

    close(fd);
    printf("\nProducer %d done!\n", id);

    return 0;
}

void produce(int id, int fd, int max_items)
{
    char buffer[BUFFER_SIZE];

    srand(time(0));
    Item item = 0;

    for (int i = 1; i <= max_items; i++)
    {
        sleep(rand()%2);
        item = 100*id + i;

        // Write to the FIFO.
        sprintf(buffer, "%d\n", item);
        write(fd, buffer, strlen(buffer) + 1);

        printf("Producer %d inserted %s", id, buffer);
        fflush(stdout);
    }
}
